## pcl 1.14.0%2Bdfsg

=== benchmarks/CMakeLists.txt ===
set(SUBSYS_NAME benchmarks)
set(SUBSYS_DESC "Point cloud library benchmarks")
set(SUBSYS_DEPS common filters features search kdtree io)
set(DEFAULT OFF)
set(build TRUE)
set(REASON "Disabled by default")
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ${DEFAULT} "${REASON}")
PCL_SUBSYS_DEPEND(build NAME ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS})
if(NOT build)
  return()
endif()

find_package(benchmark REQUIRED)
get_target_property(BenchmarkBuildType benchmark::benchmark TYPE)

add_custom_target(run_benchmarks)

PCL_ADD_BENCHMARK(features_normal_3d FILES features/normal_3d.cpp
                  LINK_WITH pcl_io pcl_search pcl_features
                  ARGUMENTS "${PCL_SOURCE_DIR}/test/table_scene_mug_stereo_textured.pcd"
                            "${PCL_SOURCE_DIR}/test/milk_cartoon_all_small_clorox.pcd")

PCL_ADD_BENCHMARK(filters_voxel_grid FILES filters/voxel_grid.cpp
                  LINK_WITH pcl_io pcl_filters
                  ARGUMENTS "${PCL_SOURCE_DIR}/test/table_scene_mug_stereo_textured.pcd"
                            "${PCL_SOURCE_DIR}/test/milk_cartoon_all_small_clorox.pcd")

PCL_ADD_BENCHMARK(search_radius_search FILES search/radius_search.cpp
                  LINK_WITH pcl_io pcl_search
                  ARGUMENTS "${PCL_SOURCE_DIR}/test/table_scene_mug_stereo_textured.pcd"
                            "${PCL_SOURCE_DIR}/test/milk_cartoon_all_small_clorox.pcd")

=== io/CMakeLists.txt ===
set(SUBSYS_NAME io)
set(SUBSYS_DESC "Point cloud IO library")
set(SUBSYS_DEPS common octree)
set(SUBSYS_EXT_DEPS boost eigen3)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
if(WIN32)
  PCL_SUBSYS_DEPEND(build NAME ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS} OPT_DEPS openni openni2 ensenso davidSDK dssdk rssdk rssdk2 pcap png vtk OpenMP EXT_DEPS ${SUBSYS_EXT_DEPS})
else()
  PCL_SUBSYS_DEPEND(build NAME ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS} OPT_DEPS openni openni2 ensenso davidSDK dssdk pcap png vtk libusb OpenMP EXT_DEPS ${SUBSYS_EXT_DEPS})
endif()

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT WIN32)
  option(PCL_IO_ENABLE_MAND_LOCKING "Enables the use of mandatory locking on filesystems mounted using the mand option." ON)
  mark_as_advanced(PCL_IO_ENABLE_MAND_LOCKING)
  if(NOT PCL_IO_ENABLE_MAND_LOCKING)
    add_definitions(-DNO_MANDATORY_LOCKING)
  endif()
endif()

if(NOT build)
  return()
endif()

if(WITH_OPENNI2)
  set(IMAGE_INCLUDES
    include/pcl/io/image_metadata_wrapper.h
    include/pcl/io/image.h
    include/pcl/io/image_rgb24.h
    include/pcl/io/image_yuv422.h
    include/pcl/io/image_ir.h
    include/pcl/io/image_depth.h
  )

  set(IMAGE_SOURCES
    src/image_rgb24.cpp
    src/image_yuv422.cpp
    src/image_ir.cpp
    src/image_depth.cpp
  )

  set(OPENNI2_GRABBER_INCLUDES
    include/pcl/io/openni2_grabber.h
  )
  set(OPENNI2_INCLUDES
    include/pcl/io/openni2/openni.h
    include/pcl/io/openni2/openni2_metadata_wrapper.h
    include/pcl/io/openni2/openni2_frame_listener.h
    include/pcl/io/openni2/openni2_timer_filter.h
    include/pcl/io/openni2/openni2_video_mode.h
    include/pcl/io/openni2/openni2_convert.h
    include/pcl/io/openni2/openni2_device.h
    include/pcl/io/openni2/openni2_device_info.h
    include/pcl/io/openni2/openni2_device_manager.h
  )

  set(OPENNI2_GRABBER_SOURCES
    src/openni2_grabber.cpp
    src/openni2/openni2_timer_filter.cpp
    src/openni2/openni2_video_mode.cpp
    src/openni2/openni2_convert.cpp
    src/openni2/openni2_device.cpp
    src/openni2/openni2_device_info.cpp
    src/openni2/openni2_device_manager.cpp
  )

  source_group("OpenNI 2\\Header Files" FILES ${OPENNI2_GRABBER_INCLUDES} ${OPENNI2_INCLUDES} ${IMAGE_INCLUDES})
  source_group("OpenNI 2\\Source Files" FILES ${OPENNI2_GRABBER_SOURCES} ${IMAGE_SOURCES})

  # Copy OpenNI2 redist directory to bin. Needed for driver modules. Only tested on Windows.
  if(MSVC)
    file(COPY ${OPENNI2_REDIST_DIR} DESTINATION ${CMAKE_BINARY_DIR}/bin PATTERN *.*)
  endif()
endif()

if(WITH_OPENNI)
  set(OPENNI_GRABBER_INCLUDES
    include/pcl/io/openni_grabber.h
    include/pcl/io/oni_grabber.h
  )

  set(OPENNI_INCLUDES
    include/pcl/io/openni_camera/openni_shift_to_depth_conversion.h
    include/pcl/io/openni_camera/openni.h
    include/pcl/io/openni_camera/openni_depth_image.h
    include/pcl/io/openni_camera/openni_device.h
    include/pcl/io/openni_camera/openni_device_kinect.h
    include/pcl/io/openni_camera/openni_device_primesense.h
    include/pcl/io/openni_camera/openni_device_xtion.h
    include/pcl/io/openni_camera/openni_device_oni.h
    include/pcl/io/openni_camera/openni_driver.h
    include/pcl/io/openni_camera/openni_exception.h
    include/pcl/io/openni_camera/openni_image.h
    include/pcl/io/openni_camera/openni_image_bayer_grbg.h
    include/pcl/io/openni_camera/openni_image_yuv_422.h
    include/pcl/io/openni_camera/openni_image_rgb24.h
    include/pcl/io/openni_camera/openni_ir_image.h
     ${IMAGE_INCLUDES}
  )
  set(OPENNI_GRABBER_SOURCES
    src/openni_camera/openni_device.cpp
    src/openni_camera/openni_device_primesense.cpp
    src/openni_camera/openni_image_bayer_grbg.cpp
    src/openni_camera/openni_depth_image.cpp
    src/openni_camera/openni_ir_image.cpp
    src/openni_camera/openni_device_kinect.cpp
    src/openni_camera/openni_device_xtion.cpp
    src/openni_camera/openni_device_oni.cpp
    src/openni_camera/openni_driver.cpp
    src/openni_camera/openni_exception.cpp
    src/openni_camera/openni_image_yuv_422.cpp
    src/openni_camera/openni_image_rgb24.cpp
    src/openni_grabber.cpp
    src/oni_grabber.cpp
    ${IMAGE_SOURCES}
  )
endif()

source_group("Image Headers" FILES ${IMAGE_INCLUDES})
source_group("Image Sources" FILES ${IMAGE_SOURCES})

if(WITH_ENSENSO)
  set(ENSENSO_GRABBER_INCLUDES
    include/pcl/io/ensenso_grabber.h
  )
  set(ENSENSO_GRABBER_SOURCES
    src/ensenso_grabber.cpp
  )
endif()

if(WITH_DAVIDSDK AND VTK_FOUND) # VTK is mandatory for OBJ/PLY/STL input/output
  set(DAVIDSDK_GRABBER_INCLUDES
    include/pcl/io/davidsdk_grabber.h
  )
  set(DAVIDSDK_GRABBER_SOURCES
    src/davidsdk_grabber.cpp
  )
endif()

if(WITH_DSSDK)
  set(DSSDK_GRABBER_INCLUDES
    include/pcl/io/depth_sense_grabber.h
  )
  set(DSSDK_GRABBER_SOURCES
    src/depth_sense_grabber.cpp
    src/depth_sense/depth_sense_grabber_impl.cpp
    src/depth_sense/depth_sense_device_manager.cpp
  )
endif()

if(WITH_RSSDK)
  set(RSSDK_GRABBER_INCLUDES
    include/pcl/io/real_sense_grabber.h
  )
  set(RSSDK_GRABBER_SOURCES
    src/real_sense_grabber.cpp
    src/real_sense/real_sense_device_manager.cpp
  )
endif()

if(WITH_RSSDK2)
  set(RSSDK2_GRABBER_INCLUDES
      include/pcl/io/real_sense_2_grabber.h
  )
  set(RSSDK2_GRABBER_SOURCES
      src/real_sense_2_grabber.cpp
  )
endif()

if(LIBUSB_FOUND)
  set(DINAST_GRABBER_INCLUDES
    include/pcl/io/dinast_grabber.h
  )
  set(DINAST_GRABBER_SOURCES
    src/dinast_grabber.cpp
  )
endif()

if(VTK_FOUND AND NOT ANDROID)
  set(VTK_IO_INCLUDES
    "include/pcl/${SUBSYS_NAME}/vtk_lib_io.h"
    "include/pcl/${SUBSYS_NAME}/png_io.h"
  )
  set(VTK_IO_INCLUDES_IMPL
    "include/pcl/${SUBSYS_NAME}/impl/vtk_lib_io.hpp"
  )
  set(VTK_IO_SOURCE
    src/vtk_lib_io.cpp
    src/png_io.cpp
  )

  # Indicates that we can rely on VTK to be present
  set(VTK_DEFINES -DPCL_BUILT_WITH_VTK)
endif()

set(PLY_SOURCES src/ply/ply_parser.cpp)
set(PLY_INCLUDES
  "include/pcl/${SUBSYS_NAME}/ply/byte_order.h"
  "include/pcl/${SUBSYS_NAME}/ply/io_operators.h"
  "include/pcl/${SUBSYS_NAME}/ply/ply.h"
  "include/pcl/${SUBSYS_NAME}/ply/ply_parser.h"
)

PCL_ADD_LIBRARY(pcl_io_ply COMPONENT ${SUBSYS_NAME} SOURCES ${PLY_SOURCES} ${PLY_INCLUDES})
if(MINGW)
  # libws2_32 isn't added by default for MinGW
  target_link_libraries(pcl_io_ply ws2_32)
endif()
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/ply" ${PLY_INCLUDES})
target_include_directories(pcl_io_ply PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")
target_link_libraries(pcl_io_ply pcl_common Boost::boost)

set(srcs
  src/debayer.cpp
  src/pcd_grabber.cpp
  src/pcd_io.cpp
  src/vtk_io.cpp
  src/ply_io.cpp
  src/ascii_io.cpp
  src/compression.cpp
  src/lzf.cpp
  src/lzf_image_io.cpp
  src/obj_io.cpp
  src/ifs_io.cpp
  src/image_grabber.cpp
  src/hdl_grabber.cpp
  src/vlp_grabber.cpp
  src/robot_eye_grabber.cpp
  src/auto_io.cpp
  src/io_exception.cpp
  src/tim_grabber.cpp
  ${VTK_IO_SOURCE}
  ${OPENNI_GRABBER_SOURCES}
  ${OPENNI2_GRABBER_SOURCES}
  ${IMAGE_SOURCES}
  ${DINAST_GRABBER_SOURCES}
  ${ENSENSO_GRABBER_SOURCES}
  ${DAVIDSDK_GRABBER_SOURCES}
  ${DSSDK_GRABBER_SOURCES}
  ${RSSDK_GRABBER_SOURCES}
  ${RSSDK2_GRABBER_SOURCES}
)

if(PNG_FOUND)
  list(APPEND srcs
    src/libpng_wrapper.cpp
  )
endif()

if(PCAP_FOUND)
  set(PCAP_DEFINES -DHAVE_PCAP)
  include_directories(SYSTEM ${PCAP_INCLUDE_DIRS})
  add_definitions(${PCAP_DEFINES})
endif()

set(incs
  "include/pcl/${SUBSYS_NAME}/boost.h"
  "include/pcl/${SUBSYS_NAME}/eigen.h"
  "include/pcl/${SUBSYS_NAME}/debayer.h"
  "include/pcl/${SUBSYS_NAME}/fotonic_grabber.h"
  "include/pcl/${SUBSYS_NAME}/file_io.h"
  "include/pcl/${SUBSYS_NAME}/auto_io.h"
  "include/pcl/${SUBSYS_NAME}/low_level_io.h"
  "include/pcl/${SUBSYS_NAME}/lzf.h"
  "include/pcl/${SUBSYS_NAME}/lzf_image_io.h"
  "include/pcl/${SUBSYS_NAME}/io.h"
  "include/pcl/${SUBSYS_NAME}/grabber.h"
  "include/pcl/${SUBSYS_NAME}/file_grabber.h"
  "include/pcl/${SUBSYS_NAME}/timestamp.h"
  "include/pcl/${SUBSYS_NAME}/pcd_grabber.h"
  "include/pcl/${SUBSYS_NAME}/pcd_io.h"
  "include/pcl/${SUBSYS_NAME}/vtk_io.h"
  "include/pcl/${SUBSYS_NAME}/ply_io.h"
  "include/pcl/${SUBSYS_NAME}/tar.h"
  "include/pcl/${SUBSYS_NAME}/obj_io.h"
  "include/pcl/${SUBSYS_NAME}/ascii_io.h"
  "include/pcl/${SUBSYS_NAME}/ifs_io.h"
  "include/pcl/${SUBSYS_NAME}/image_grabber.h"
  "include/pcl/${SUBSYS_NAME}/hdl_grabber.h"
  "include/pcl/${SUBSYS_NAME}/vlp_grabber.h"
  "include/pcl/${SUBSYS_NAME}/robot_eye_grabber.h"
  "include/pcl/${SUBSYS_NAME}/point_cloud_image_extractors.h"
  "include/pcl/${SUBSYS_NAME}/io_exception.h"
  "include/pcl/${SUBSYS_NAME}/tim_grabber.h"
  ${VTK_IO_INCLUDES}
  ${OPENNI_GRABBER_INCLUDES}
  ${OPENNI2_GRABBER_INCLUDES}
  ${IMAGE_INCLUDES}
  ${DINAST_GRABBER_INCLUDES}
  ${ENSENSO_GRABBER_INCLUDES}
  ${DAVIDSDK_GRABBER_INCLUDES}
  ${DSSDK_GRABBER_INCLUDES}
  ${RSSDK_GRABBER_INCLUDES}
  ${RSSDK2_GRABBER_INCLUDES}
)

set(compression_incs
  include/pcl/compression/octree_pointcloud_compression.h
  include/pcl/compression/color_coding.h
  include/pcl/compression/compression_profiles.h
  include/pcl/compression/entropy_range_coder.h
  include/pcl/compression/point_coding.h
)

if(PNG_FOUND)
  list(APPEND compression_incs
    include/pcl/compression/organized_pointcloud_conversion.h
    include/pcl/compression/libpng_wrapper.h
  )
  if(WITH_OPENNI OR WITH_OPENNI2)
  list(APPEND compression_incs
    include/pcl/compression/organized_pointcloud_compression.h
  )
  endif()
endif()

set(impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/ascii_io.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/pcd_io.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/auto_io.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/lzf_image_io.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/synchronized_queue.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/point_cloud_image_extractors.hpp"
  include/pcl/compression/impl/entropy_range_coder.hpp
  include/pcl/compression/impl/octree_pointcloud_compression.hpp
  ${VTK_IO_INCLUDES_IMPL}
)

if(PNG_FOUND AND (WITH_OPENNI OR WITH_OPENNI2))
  list(APPEND impl_incs
    include/pcl/compression/impl/organized_pointcloud_compression.hpp
  )
endif()

set(LIB_NAME "pcl_${SUBSYS_NAME}")

add_definitions(${VTK_DEFINES})

PCL_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs} ${compression_incs} ${impl_incs} ${OPENNI_INCLUDES} ${OPENNI2_INCLUDES})

target_include_directories(${LIB_NAME} PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")

target_link_libraries("${LIB_NAME}" Boost::boost Boost::filesystem Boost::iostreams pcl_common pcl_io_ply)

if(VTK_FOUND)
  if(${VTK_VERSION} VERSION_GREATER_EQUAL 9.0)
    target_link_libraries("${LIB_NAME}" 
                          VTK::FiltersGeneral
                          VTK::IOImage
                          VTK::IOGeometry
                          VTK::IOPLY)
  else()
    link_directories(${VTK_LINK_DIRECTORIES})
    target_link_libraries("${LIB_NAME}"
                          vtkIOImage
                          vtkIOGeometry
                          vtkIOPLY
                          )
    if(${VTK_VERSION} VERSION_LESS 8.0)
      target_link_libraries("${LIB_NAME}" vtkIOMPIImage vtkIOMPIParallel)
      if(${VTK_VERSION} VERSION_GREATER_EQUAL 7.0)
        target_link_libraries("${LIB_NAME}" vtkFiltersParallelDIY2)
      endif()
    else()
      target_link_libraries("${LIB_NAME}" vtkImagingCore)
    endif()
  endif()
endif()

if(PNG_FOUND)
  target_link_libraries("${LIB_NAME}" ${PNG_LIBRARIES})
endif()

if(LIBUSB_FOUND)
  target_link_libraries("${LIB_NAME}" libusb::libusb)
endif()

if(WITH_OPENNI2)
  target_link_libraries(${LIB_NAME} ${OPENNI2_LIBRARIES})
endif()

if(WITH_OPENNI)
  target_link_libraries("${LIB_NAME}" ${OPENNI_LIBRARIES})
  if(VTK_FOUND AND (NOT ${VTK_VERSION} VERSION_LESS 9.0))
    target_link_libraries("${LIB_NAME}" VTK::FiltersCore VTK::FiltersGeneral)
  endif()
endif()

if(WITH_FZAPI)
  target_link_libraries("${LIB_NAME}" ${FZAPI_LIBS})
  if(WIN32)
  target_link_libraries("${LIB_NAME}" Version.lib)
  endif()
endif()

if(WITH_ENSENSO)

=== segmentation/CMakeLists.txt ===
set(SUBSYS_NAME segmentation)
set(SUBSYS_DESC "Point cloud segmentation library")
set(SUBSYS_DEPS common geometry search sample_consensus kdtree octree features filters ml)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build NAME ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS} OPT_DEPS OpenMP)

PCL_ADD_DOC("${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

set(srcs
  src/extract_clusters.cpp
  src/extract_polygonal_prism_data.cpp
  src/min_cut_segmentation.cpp
  src/sac_segmentation.cpp
  src/seeded_hue_segmentation.cpp
  src/segment_differences.cpp
  src/region_growing.cpp
  src/region_growing_rgb.cpp
  src/organized_connected_component_segmentation.cpp
  src/organized_multi_plane_segmentation.cpp
  src/planar_polygon_fusion.cpp
  src/crf_segmentation.cpp
  src/unary_classifier.cpp
  src/conditional_euclidean_clustering.cpp
  src/supervoxel_clustering.cpp
  src/grabcut_segmentation.cpp
  src/progressive_morphological_filter.cpp
  src/approximate_progressive_morphological_filter.cpp
  src/lccp_segmentation.cpp
  src/cpc_segmentation.cpp
)

set(incs
  "include/pcl/${SUBSYS_NAME}/boost.h"
  "include/pcl/${SUBSYS_NAME}/extract_clusters.h"
  "include/pcl/${SUBSYS_NAME}/extract_labeled_clusters.h"
  "include/pcl/${SUBSYS_NAME}/extract_polygonal_prism_data.h"
  "include/pcl/${SUBSYS_NAME}/min_cut_segmentation.h"
  "include/pcl/${SUBSYS_NAME}/sac_segmentation.h"
  "include/pcl/${SUBSYS_NAME}/seeded_hue_segmentation.h"
  "include/pcl/${SUBSYS_NAME}/segment_differences.h"
  "include/pcl/${SUBSYS_NAME}/region_growing.h"
  "include/pcl/${SUBSYS_NAME}/region_growing_rgb.h"
  "include/pcl/${SUBSYS_NAME}/comparator.h"
  "include/pcl/${SUBSYS_NAME}/plane_coefficient_comparator.h"
  "include/pcl/${SUBSYS_NAME}/euclidean_plane_coefficient_comparator.h"
  "include/pcl/${SUBSYS_NAME}/edge_aware_plane_comparator.h"
  "include/pcl/${SUBSYS_NAME}/rgb_plane_coefficient_comparator.h"
  "include/pcl/${SUBSYS_NAME}/plane_refinement_comparator.h"
  "include/pcl/${SUBSYS_NAME}/euclidean_cluster_comparator.h"
  "include/pcl/${SUBSYS_NAME}/ground_plane_comparator.h"
  "include/pcl/${SUBSYS_NAME}/organized_connected_component_segmentation.h"
  "include/pcl/${SUBSYS_NAME}/organized_multi_plane_segmentation.h"
  "include/pcl/${SUBSYS_NAME}/random_walker.h"
  "include/pcl/${SUBSYS_NAME}/region_3d.h"
  "include/pcl/${SUBSYS_NAME}/planar_region.h"
  "include/pcl/${SUBSYS_NAME}/planar_polygon_fusion.h"
  "include/pcl/${SUBSYS_NAME}/crf_segmentation.h"
  "include/pcl/${SUBSYS_NAME}/crf_normal_segmentation.h"
  "include/pcl/${SUBSYS_NAME}/unary_classifier.h"
  "include/pcl/${SUBSYS_NAME}/conditional_euclidean_clustering.h"
  "include/pcl/${SUBSYS_NAME}/supervoxel_clustering.h"
  "include/pcl/${SUBSYS_NAME}/grabcut_segmentation.h"
  "include/pcl/${SUBSYS_NAME}/progressive_morphological_filter.h"
  "include/pcl/${SUBSYS_NAME}/approximate_progressive_morphological_filter.h"
  "include/pcl/${SUBSYS_NAME}/lccp_segmentation.h"
  "include/pcl/${SUBSYS_NAME}/cpc_segmentation.h"
)

set(impl_incs
  "include/pcl/${SUBSYS_NAME}/impl/extract_clusters.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/extract_labeled_clusters.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/extract_polygonal_prism_data.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/min_cut_segmentation.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/sac_segmentation.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/seeded_hue_segmentation.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/segment_differences.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/random_walker.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/region_growing.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/region_growing_rgb.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/organized_connected_component_segmentation.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/organized_multi_plane_segmentation.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/planar_polygon_fusion.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/crf_segmentation.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/unary_classifier.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/crf_normal_segmentation.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/conditional_euclidean_clustering.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/supervoxel_clustering.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/grabcut_segmentation.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/progressive_morphological_filter.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/approximate_progressive_morphological_filter.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/lccp_segmentation.hpp"
  "include/pcl/${SUBSYS_NAME}/impl/cpc_segmentation.hpp"
)

set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
PCL_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs} ${impl_incs})
target_link_libraries("${LIB_NAME}" pcl_search pcl_sample_consensus pcl_filters pcl_ml pcl_features)
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS})

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_NAME}/impl" ${impl_incs})

=== cuda/features/CMakeLists.txt ===
set(SUBSYS_NAME cuda_features)
set(SUBSYS_PATH cuda/features)
set(SUBSYS_DESC "Point Cloud CUDA Feature Estimation library")
set(SUBSYS_DEPS cuda_common io common)

# ---[ Point Cloud Library - pcl/cuda/io

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
mark_as_advanced("BUILD_${SUBSYS_NAME}")
PCL_SUBSYS_DEPEND(build NAME ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS})
PCL_SET_SUBSYS_INCLUDE_DIR("${SUBSYS_NAME}" "${SUBSYS_PATH}")

if(NOT build)
  return()
endif()

set(srcs
  src/normal_3d.cu
)

set(incs
  include/pcl/cuda/features/normal_3d.h
)

set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
PCL_CUDA_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs})
target_link_libraries(${LIB_NAME} pcl_common)

set(EXT_DEPS "")
#set(EXT_DEPS CUDA)
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS} EXT_DEPS ${EXT_DEPS})

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_PATH}" ${incs})

=== cuda/sample_consensus/CMakeLists.txt ===
set(SUBSYS_NAME cuda_sample_consensus)
set(SUBSYS_PATH cuda/sample_consensus)
set(SUBSYS_DESC "Point Cloud CUDA Sample Consensus library")
set(SUBSYS_DEPS cuda_common io common)

# ---[ Point Cloud Library - pcl/cuda/io

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
mark_as_advanced("BUILD_${SUBSYS_NAME}")
PCL_SUBSYS_DEPEND(build NAME ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS})
PCL_SET_SUBSYS_INCLUDE_DIR("${SUBSYS_NAME}" "${SUBSYS_PATH}")

if(NOT build)
  return()
endif()

set(srcs
  src/sac_model.cu
  src/sac_model_plane.cu
  src/sac_model_1point_plane.cu
  src/ransac.cu
  src/multi_ransac.cu
)

set(incs
  include/pcl/cuda/sample_consensus/sac.h
  include/pcl/cuda/sample_consensus/ransac.h
  include/pcl/cuda/sample_consensus/multi_ransac.h
  include/pcl/cuda/sample_consensus/sac_model.h
  include/pcl/cuda/sample_consensus/sac_model_plane.h
  include/pcl/cuda/sample_consensus/sac_model_1point_plane.h
)

set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
PCL_CUDA_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs})
target_link_libraries("${LIB_NAME}" pcl_cuda_features)

set(EXT_DEPS "")
#set(EXT_DEPS CUDA)
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS} EXT_DEPS ${EXT_DEPS})

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_PATH}" ${incs})

=== cuda/segmentation/CMakeLists.txt ===
set(SUBSYS_NAME cuda_segmentation)
set(SUBSYS_PATH cuda/segmentation)
set(SUBSYS_DESC "Point cloud CUDA Segmentation library")
set(SUBSYS_DEPS cuda_common io common)

# ---[ Point Cloud Library - pcl/cuda/io

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
mark_as_advanced("BUILD_${SUBSYS_NAME}")
PCL_SUBSYS_DEPEND(build NAME ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS})
PCL_SET_SUBSYS_INCLUDE_DIR("${SUBSYS_NAME}" "${SUBSYS_PATH}")


if(NOT build)
  return()
endif()

set(incs
  include/pcl/cuda/segmentation/connected_components.h
)

set(srcs
  src/connected_components.cu
)

set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
PCL_CUDA_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs})
target_link_libraries(${LIB_NAME} pcl_common)

set(EXT_DEPS "")
#set(EXT_DEPS CUDA)
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS} EXT_DEPS ${EXT_DEPS})

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_PATH}" ${incs})

=== examples/outofcore/CMakeLists.txt ===
if(NOT BUILD_outofcore)
  return()
endif()

# Find VTK
if(NOT VTK_FOUND)
  set(DEFAULT FALSE)
  set(REASON "VTK was not found.")
else()
  set(DEFAULT TRUE)
  set(REASON)
endif()

PCL_SUBSYS_DEPEND(build NAME ${SUBSYS_NAME} DEPS outofcore io common octree filters visualization EXT_DEPS vtk)
PCL_ADD_EXAMPLE (pcl_example_outofcore_with_lod FILES example_outofcore_with_lod.cpp LINK_WITH pcl_outofcore pcl_common pcl_io pcl_octree pcl_filters)
PCL_ADD_EXAMPLE (pcl_example_outofcore FILES example_outofcore.cpp LINK_WITH pcl_outofcore pcl_common pcl_io pcl_octree pcl_filters)

=== gpu/features/CMakeLists.txt ===
set(SUBSYS_NAME gpu_features)
set(SUBSYS_PATH gpu/features)
set(SUBSYS_DESC "Temporary GPU_common module. Weak CUDA dependency: a code that use this module requires CUDA Toolkit installed, but should be compiled without nvcc")
set(SUBSYS_DEPS common gpu_containers gpu_utils gpu_octree geometry)

set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ON)
PCL_SUBSYS_DEPEND(build NAME ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS})
PCL_SET_SUBSYS_INCLUDE_DIR("${SUBSYS_NAME}" "${SUBSYS_PATH}")
mark_as_advanced("BUILD_${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

file(GLOB incs include/pcl/gpu/features/*.hpp)
file(GLOB srcs src/*.cpp src/*.hpp)
file(GLOB cuda src/*.cu)
file(GLOB dev_incs include/pcl/gpu/features/device/*.h*)
source_group("Header Files\\device" FILES ${dev_incs})
source_group("Source Files\\cuda" FILES ${cuda})
source_group("Source Files" FILES ${srcs})

file(GLOB srcs_utils src/utils/*.hpp)
source_group("Source Files\\utils" FILES ${srcs_utils})

set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include" "${CMAKE_CURRENT_SOURCE_DIR}/src")
PCL_CUDA_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs} ${cuda} ${srcs_utils}  ${dev_incs})
target_link_libraries("${LIB_NAME}" pcl_gpu_utils pcl_gpu_containers pcl_gpu_octree)

set(EXT_DEPS "")
#set(EXT_DEPS CUDA)
PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS} EXT_DEPS ${EXT_DEPS})

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_PATH}" ${incs})
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_PATH}/device" ${dev_incs})

add_subdirectory(test)

=== gpu/kinfu/CMakeLists.txt ===
set(SUBSYS_NAME gpu_kinfu)
set(SUBSYS_PATH gpu/kinfu)
set(SUBSYS_DESC "Kinect Fusion implementation")
set(SUBSYS_DEPS common io gpu_containers geometry search)
if(${CUDA_VERSION_STRING} VERSION_GREATER_EQUAL "12.0")
  set(DEFAULT FALSE)
  set(REASON "Kinfu uses textures which was removed in CUDA 12")
else()
  set(DEFAULT TRUE)
endif()

PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ${DEFAULT} "${REASON}")
PCL_SUBSYS_DEPEND(build NAME ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS})
PCL_SET_SUBSYS_INCLUDE_DIR("${SUBSYS_NAME}" "${SUBSYS_PATH}")
mark_as_advanced("BUILD_${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

file(GLOB incs include/pcl/gpu/kinfu/*.h*)
file(GLOB srcs src/*.cpp src/*.h*)
file(GLOB cuda src/cuda/*.cu src/cuda/*.h*)

source_group("Source Files\\cuda" FILES ${cuda})
source_group("Source Files" FILES ${srcs})

set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include" "${CMAKE_CURRENT_SOURCE_DIR}/src")

PCL_CUDA_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs} ${cuda})
target_link_libraries(${LIB_NAME} pcl_cuda pcl_gpu_containers)

target_compile_options(${LIB_NAME} PRIVATE $<$<COMPILE_LANGUAGE:CUDA>:--ftz=true;--prec-div=false;--prec-sqrt=false>)

PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS} EXT_DEPS ${EXT_DEPS})

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_PATH}" ${incs})

if(BUILD_tools)
  add_subdirectory(tools)
endif()

=== gpu/kinfu_large_scale/CMakeLists.txt ===
set(SUBSYS_NAME gpu_kinfu_large_scale)
set(SUBSYS_PATH gpu/kinfu_large_scale)
set(SUBSYS_DESC "Kinect Fusion implementation, with volume shifting")
set(SUBSYS_DEPS common io gpu_containers gpu_utils geometry search octree filters kdtree features surface)
if(${CUDA_VERSION_STRING} VERSION_GREATER_EQUAL "12.0")
  set(DEFAULT FALSE)
  set(REASON "Kinfu_large_scale uses textures which was removed in CUDA 12")
else()
  set(DEFAULT TRUE)
endif()

PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ${DEFAULT} "${REASON}")
PCL_SUBSYS_DEPEND(build NAME ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS})
PCL_SET_SUBSYS_INCLUDE_DIR("${SUBSYS_NAME}" "${SUBSYS_PATH}")
mark_as_advanced("BUILD_${SUBSYS_NAME}")

if(NOT build)
  return()
endif()

file(GLOB incs include/pcl/gpu/kinfu_large_scale/*.h*)
file(GLOB impl_incs include/pcl/gpu/kinfu_large_scale/impl/*.h*)
file(GLOB srcs src/*.cpp src/*.h*)
file(GLOB cuda src/cuda/*.cu src/cuda/*.h*)

source_group("Source Files\\cuda" FILES ${cuda})
source_group("Source Files" FILES ${srcs})

set(LIB_NAME "pcl_${SUBSYS_NAME}")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include" "${CMAKE_CURRENT_SOURCE_DIR}/src")

PCL_CUDA_ADD_LIBRARY(${LIB_NAME} COMPONENT ${SUBSYS_NAME} SOURCES ${srcs} ${incs} ${impl_incs} ${cuda})

target_link_libraries(${LIB_NAME} pcl_cuda pcl_common pcl_io pcl_gpu_utils pcl_gpu_containers pcl_gpu_octree pcl_octree pcl_filters)

target_compile_options(${LIB_NAME} PRIVATE $<$<COMPILE_LANGUAGE:CUDA>:--ftz=true;--prec-div=false;--prec-sqrt=false>)

PCL_MAKE_PKGCONFIG(${LIB_NAME} COMPONENT ${SUBSYS_NAME} DESC ${SUBSYS_DESC} PCL_DEPS ${SUBSYS_DEPS} EXT_DEPS ${EXT_DEPS})

# Install include files
PCL_ADD_INCLUDES("${SUBSYS_NAME}" "${SUBSYS_PATH}" ${incs})

if(BUILD_tools)
  add_subdirectory(tools)
endif()

=== test/geometry/CMakeLists.txt ===
set(SUBSYS_NAME tests_geometry)
set(SUBSYS_DESC "Point cloud library geometry module unit tests")
PCL_SET_TEST_DEPENDENCIES(SUBSYS_DEPS geometry)

set(DEFAULT ON)
set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ${DEFAULT} "${REASON}")
PCL_SUBSYS_DEPEND(build NAME ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS} OPT_DEPS ${OPT_DEPS})

if(NOT build)
  return()
endif()

PCL_ADD_TEST(geometry_iterator test_iterator
             FILES test_iterator.cpp
             LINK_WITH pcl_gtest pcl_geometry)

PCL_ADD_TEST(geometry_mesh_circulators test_mesh_circulators
             FILES test_mesh_circulators.cpp
             LINK_WITH pcl_gtest pcl_geometry)

PCL_ADD_TEST(geometry_mesh_conversion test_mesh_conversion
             FILES test_mesh_conversion.cpp
             LINK_WITH pcl_gtest pcl_geometry)

PCL_ADD_TEST(geometry_mesh_data test_mesh_data
             FILES test_mesh_data.cpp
             LINK_WITH pcl_gtest pcl_geometry)

PCL_ADD_TEST(geometry_mesh_get_boundary test_mesh_get_boundary
             FILES test_mesh_get_boundary.cpp
             LINK_WITH pcl_gtest pcl_geometry)

PCL_ADD_TEST(geometry_mesh_indices test_mesh_indices
             FILES test_mesh_indices.cpp
             LINK_WITH pcl_gtest pcl_geometry)

add_definitions(-DPCL_TEST_GEOMETRY_BINARY_DIR="${CMAKE_CURRENT_BINARY_DIR}")
PCL_ADD_TEST(geometry_mesh_io test_mesh_io
             FILES test_mesh_io.cpp
             LINK_WITH pcl_gtest pcl_geometry)

PCL_ADD_TEST(geometry_mesh test_mesh
             FILES test_mesh.cpp test_mesh_common_functions.h
             LINK_WITH pcl_gtest pcl_geometry)

PCL_ADD_TEST(geometry_polygon_mesh test_polygon_mesh
             FILES test_polygon_mesh.cpp
             LINK_WITH pcl_gtest pcl_geometry)

PCL_ADD_TEST(geometry_quad_mesh test_quad_mesh
             FILES test_quad_mesh.cpp
             LINK_WITH pcl_gtest pcl_geometry)

PCL_ADD_TEST(geometry_triangle_mesh test_triangle_mesh
             FILES test_triangle_mesh.cpp
             LINK_WITH pcl_gtest pcl_geometry)

=== test/ml/CMakeLists.txt ===
set(SUBSYS_NAME tests_ml)
set(SUBSYS_DESC "Point cloud library ml module unit tests")
PCL_SET_TEST_DEPENDENCIES(SUBSYS_DEPS ml)

set(DEFAULT ON)
set(build TRUE)
PCL_SUBSYS_OPTION(build "${SUBSYS_NAME}" "${SUBSYS_DESC}" ${DEFAULT} "${REASON}")
PCL_SUBSYS_DEPEND(build NAME ${SUBSYS_NAME} DEPS ${SUBSYS_DEPS} OPT_DEPS ${OPT_DEPS})

if(NOT build)
  return()
endif()

PCL_ADD_TEST(ml_kmeans test_ml_kmeans FILES test_kmeans.cpp LINK_WITH pcl_gtest pcl_common pcl_ml)

=== debian/control ===
Source: pcl
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jochen Sprickerhof <jspricke@debian.org>,
	   Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
	       clang [mipsel armel armhf],
	       python3-sphinx,
	       libboost-system-dev,
	       libboost-filesystem-dev,
	       libboost-thread-dev,
	       libboost-date-time-dev,
	       libboost-iostreams-dev,
	       libeigen3-dev,
	       libflann-dev,
	       libvtk9-dev,
	       libqhull-dev,
	       libopenni-dev [!s390x !alpha !hppa !hurd-i386 !ia64 !kfreebsd-any !m68k !riscv64 !sh4 !sparc64],
	       libopenni2-dev [!hurd-i386 !hppa !kfreebsd-any],
	       libqt5opengl5-dev,
	       libusb-1.0-0-dev,
	       libglut-dev,
	       libxmu-dev,
	       libxi-dev,
	       libpcap-dev,
	       libvtk9-qt-dev,
	       libglew-dev,
	       libgtest-dev,
Build-Depends-Indep: doxygen,
		     doxygen-latex
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/pcl
Vcs-Git: https://salsa.debian.org/science-team/pcl.git
Rules-Requires-Root: no
Homepage: https://www.pointclouds.org/
Description: Point Cloud Library
 The Point Cloud Library (PCL) is a standalone, large scale, open
 project for 2D/3D image and point cloud processing.
 .
 The PCL framework contains numerous state-of-the art algorithms
 including filtering, feature estimation, surface reconstruction,
 registration, model fitting and segmentation.

Package: libpcl-dev
Architecture: any
Section: libdevel
Depends: libboost-all-dev,
	 libeigen3-dev,
	 libflann-dev,
	 libvtk9-dev,
	 libqhull-dev,
	 libvtk9-qt-dev,
	 libusb-1.0-0-dev,
	 libopenni-dev [!s390x !alpha !hppa !hurd-i386 !ia64 !kfreebsd-any !m68k !riscv64 !sh4 !sparc64],
	 libopenni2-dev [!hurd-i386 !hppa !kfreebsd-any],
	 libpcl-apps1.14 (= ${binary:Version}),
	 libpcl-common1.14 (= ${binary:Version}),
	 libpcl-features1.14 (= ${binary:Version}),
	 libpcl-filters1.14 (= ${binary:Version}),
	 libpcl-io1.14 (= ${binary:Version}),
	 libpcl-kdtree1.14 (= ${binary:Version}),
	 libpcl-keypoints1.14 (= ${binary:Version}),
	 libpcl-ml1.14 (= ${binary:Version}),
	 libpcl-octree1.14 (= ${binary:Version}),
	 libpcl-outofcore1.14 (= ${binary:Version}),
	 libpcl-people1.14 (= ${binary:Version}),
	 libpcl-recognition1.14 (= ${binary:Version}),
	 libpcl-registration1.14 (= ${binary:Version}),
	 libpcl-sample-consensus1.14 (= ${binary:Version}),
	 libpcl-search1.14 (= ${binary:Version}),
	 libpcl-segmentation1.14 (= ${binary:Version}),
	 libpcl-stereo1.14 (= ${binary:Version}),
	 libpcl-surface1.14 (= ${binary:Version}),
	 libpcl-tracking1.14 (= ${binary:Version}),
	 libpcl-visualization1.14 (= ${binary:Version}),
	 ${misc:Depends}
Suggests: libpcl-doc
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}
 .
 This package contains development files (headers and shared library
 symbolic link).

Package: libpcl-apps1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - apps library
 ${source:Extended-Description}
 .
 This package contains the libraries needed to run applications depending
 on PCL apps.

Package: libpcl-common1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - common library
 ${source:Extended-Description}
 .
 This package contains the PCL common library.

Package: libpcl-features1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - features library
 ${source:Extended-Description}
 .
 This package contains the PCL features library.

Package: libpcl-filters1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - filters library
 ${source:Extended-Description}
 .
 This package contains the PCL filters library.

Package: libpcl-io1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - I/O library
 ${source:Extended-Description}
 .
 This package contains the libraries needed to run applications
 depending on PCL io.

Package: libpcl-kdtree1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - kdtree library
 ${source:Extended-Description}
 .
 This package contains the PCL kdtree library.

Package: libpcl-keypoints1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - keypoints library
 ${source:Extended-Description}
 .
 This package contains the PCL keypoints library.

Package: libpcl-ml1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - ml library
 ${source:Extended-Description}
 .
 This package contains the PCL ml library.

Package: libpcl-octree1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - octree library
 ${source:Extended-Description}
 .
 This package contains the PCL octree library.

Package: libpcl-outofcore1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
	 ${misc:Depends}
Description: ${source:Synopsis} - outofcore library
 ${source:Extended-Description}
 .
 This package contains the libraries needed to run applications
 depending on PCL outofcore.

Package: libpcl-people1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
	 ${misc:Depends}
Description: ${source:Synopsis} - people library
 ${source:Extended-Description}
 .
 This package contains the libraries needed to run applications
 depending on PCL people.

Package: libpcl-recognition1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
    	 ${misc:Depends}
Description: ${source:Synopsis} - recognition library
 ${source:Extended-Description}
 .
 This package contains the libraries needed to run applications
 depending on PCL recognition.

Package: libpcl-registration1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - registration library
 ${source:Extended-Description}
 .
 This package contains the PCL registration library.

Package: libpcl-sample-consensus1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - sample consensus library
 ${source:Extended-Description}
 .
 This package contains the PCL sample consensus library.

Package: libpcl-search1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - search library
 ${source:Extended-Description}
 .
 This package contains the PCL search library.

Package: libpcl-segmentation1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - segmentation library
 ${source:Extended-Description}
 .
 This package contains the PCL segmentation library.

Package: libpcl-stereo1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - stereo library
 ${source:Extended-Description}
 .
 This package contains the PCL stereo library.

Package: libpcl-surface1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - surface library
 ${source:Extended-Description}
 .
 This package contains the PCL surface library.

Package: libpcl-tracking1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - tracking library
 ${source:Extended-Description}
 .
 This package contains the PCL tracking library.

Package: libpcl-visualization1.14
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} - visualization library
 ${source:Extended-Description}
 .
 This package contains the PCL visualization library.

Package: pcl-tools
Architecture: any
Section: science
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: foreign
Description: ${source:Synopsis} - point cloud processing tools
 ${source:Extended-Description}
 .
 This package gathers tools bundled with PCL to process point clouds.

Package: libpcl-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-jquery
Multi-Arch: foreign
Description: ${source:Synopsis} - documentation
 ${source:Extended-Description}
 .
 This package contains the Doxygen generated documentation.

=== debian/rules ===
#!/usr/bin/make -f

# Hardening.
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND = -g1

BUILD_DOC = $(if $(shell dh_listpackages | grep libpcl-doc),-DWITH_DOCS=ON)

# use clang on some archs as gcc is running into "virtual memory exhausted"
ifneq (,$(filter $(DEB_BUILD_ARCH),mipsel armhf armel))
  PARALLEL=--max-parallel=2
  export CC=/usr/bin/clang
  export CXX=/usr/bin/clang++
  # fails with "Unknown debugging section .debug_addr"
  # https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1016936
  # can be removed once dwz is fixed
override_dh_dwz:
else
  PARALLEL=
endif

ifneq (,$(filter $(DEB_BUILD_ARCH),s390x powerpc ppc64 riscv64))
  RUN_TESTS=
else
  RUN_TESTS=-DBUILD_global_tests=ON -DBUILD_TESTS=ON

override_dh_auto_test:
	make -C obj-${DEB_HOST_GNU_TYPE} tests

endif

override_dh_auto_configure:
	dh_auto_configure -- 						\
	-DLIB_INSTALL_DIR:STRING="lib/$(DEB_HOST_MULTIARCH)"		\
	-DCMAKE_SKIP_RPATH=ON -DPCL_ENABLE_SSE=OFF			\
	-DBUILD_apps_in_hand_scanner=ON \
	-DBUILD_apps_modeler=ON \
	-DBUILD_apps=ON \
	-DBUILD_apps_point_cloud_editor=ON \
	-DPCL_DISABLE_GPU_TESTS=ON \
	$(BUILD_DOC) $(RUN_TESTS)

%:
	dh $@ $(PARALLEL)
